<?php
/**
 * Plugin Name: Auto Select Available Date For Customer
 * Plugin URI: https://pluginhive.com/
 * Description: An Add-on for PluginHive Woocommerce Booking and Appointments plugin to auto select the available date for customer.
 * Version: 1.0.0
 * Author: pluginhive
 * Author URI: https://pluginhive.com
 * Text Domain: bookings-and-appointments-for-woocommerce
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

// Define PH_BOOKINGS_AUTO_SELECT_NEXT_AVAILABLE_DATE_PLUGIN_FILE.
if ( ! defined( 'PH_BOOKINGS_AUTO_SELECT_NEXT_AVAILABLE_DATE_FOR_CUSTOMER_PLUGIN_FILE' ) )
	define( 'PH_BOOKINGS_AUTO_SELECT_NEXT_AVAILABLE_DATE_FOR_CUSTOMER_PLUGIN_FILE', __FILE__ );

	define( 'PH_BOOKING_AUTO_SELECT_NEXT_AVAILABLE_DATE_FOR_CUSTOMER_SETTING_ID', 'ph_bookings_auto_select_date_for_customer' );


function ph_bookings_activation_check_for_auto_select_next_available_date_for_customer_addon(){

    if ( !is_plugin_active('ph-bookings-appointments-woocommerce-premium/ph-bookings-appointments-woocommerce-premium.php') ){
        deactivate_plugins( basename( __FILE__ ) );
        wp_die( __("Oops! You tried installing the Auto Select Next Available Date Plugin without activating Bookings and Appointments For WooCommerce Premium Plugin. Kindly activate <b>Bookings and Appointments For WooCommerce Premium Plugin</b> and then try again", "bookings-and-appointments-for-woocommerce" ), "", array('back_link' => 1 ));
    }
}

register_activation_hook( __FILE__, 'ph_bookings_activation_check_for_auto_select_next_available_date_for_customer_addon' );

//check if woocommerce exists
if ( !class_exists( 'woocommerce' ) || !class_exists('phive_booking_initialze_premium') ) {
    add_action( 'admin_init', 'Ph_Bookings_Auto_Select_Next_Available_Date_For_Customer_deactivate' );
    if ( ! function_exists( 'Ph_Bookings_Auto_Select_Next_Available_Date_For_Customer_deactivate' ) ) {
        function Ph_Bookings_Auto_Select_Next_Available_Date_For_Customer_deactivate() {
            if ( !class_exists( 'woocommerce' ) || !class_exists('phive_booking_initialze_premium') ){
                deactivate_plugins( plugin_basename( __FILE__ ) );
                wp_safe_redirect( admin_url('plugins.php') );

            }
        }
    }
}

if( ! class_exists('Ph_Bookings_Auto_Select_Next_Available_Date_For_Customer') ) {
	class Ph_Bookings_Auto_Select_Next_Available_Date_For_Customer {

		/**
		 * Constructor
		 */
		public function __construct() {
			$restrict_start_day=array();
			$booking_start_days=array();

			add_action('wp_footer',array($this,'phive_booking_scripts'));
			add_filter( 'ph_booking_calendar_start_date' , array( $this, 'get_next_available_date' ),10,2 );

			// add_filter('ph_modify_start_date_while_reloading', array( $this, 'get_next_available_date' ),10,2);
			add_action( 'wp_ajax_ph_booking_check_time_availability', array($this,'ph_booking_check_time_availability') );
			add_action( 'wp_ajax_nopriv_ph_booking_check_time_availability', array($this,'ph_booking_check_time_availability') );
			
		}

		/**
		 * Init
		 */
		public function init(){
				// include_once 'includes/class-ph-bookings-auto-select-date-settings.php';
		}

		public function ph_booking_check_time_availability(){
			$date=$this->check_next_available_time($_POST['date'],$_POST['product_id']);
			if($date==$_POST['date'])
			{
				echo 1;die;
			}
			else
			{
				echo 0;die;
			}

		}
		public function check_next_available_time($start_date,$product_id){
			$curr_date=strtotime(date("Y-m-d"));
			$curr_date=strtotime($start_date);
			$calendar_for='time-picker';
			$this->shop_opening_time		= get_post_meta( $product_id, "_phive_book_working_hour_start", 1 );
			$this->shop_closing_time		= get_post_meta( $product_id, "_phive_book_working_hour_end", 1 );
			$this->interval					= get_post_meta( $product_id, "_phive_book_interval", 1 );
			$this->interval_period			= get_post_meta( $product_id, "_phive_book_interval_period", 1 );
			$this->zone 					= get_option('gmt_offset');
			$this->buffer_before_time		= get_post_meta($product_id,"_phive_buffer_before",1);
			$this->buffer_after_time		= get_post_meta($product_id,"_phive_buffer_after",1);

			$buffer_period			=get_post_meta($product_id,"_phive_buffer_period",1);
			$phive_enable_buffer	= get_post_meta($product_id,"_phive_enable_buffer",1);
			if( ! class_exists('phive_booking_calendar_strategy') )
				include_once WP_PLUGIN_DIR . '/ph-bookings-appointments-woocommerce-premium/includes/frondend/class-ph-booking-calendar-strategy.php';
			$calendar_strategy=new phive_booking_calendar_strategy($product_id);
			// error_log("message");
			$end_date=strtotime(date('Y-m-d',strtotime("+1 year",$curr_date)));
			while ($curr_date < $end_date) {
				// $available_slot = $this->get_number_of_available_slot( $curr_date, $product_id, '');
				$date=date("Y-m-d",$curr_date);
				$start_time = $date.' '.$this->get_shop_opening_time($product_id,date("Y-m-d",$curr_date));
				// if(strtotime(date("Y-m-d H:i")) > strtotime($start_time))
				// {
				// 	$curr_date = strtotime( date ( "Y-m-d", strtotime( "+1 day", $curr_date ) ) );
				// 	continue;
				// }
				$end_time		= strtotime( "+1 day", strtotime(date('Y-m-d 00:00',(strtotime($start_time)))) );
				$interval=0;
				$loop_breaker 			= 200;
				// error_log("start");
				// error_log("start_time :  ".$start_time);
				// error_log("end_time :  ".date("Y-m-d H:i",$end_time));
				while ( strtotime($start_time) < $end_time && $loop_breaker>0 ) {
					// error_log($start_time);
					// error_log("inside");
					$start_time	= strtotime($start_time);
			
					if( $this->is_working_time( $start_time, $product_id )){
							// error_log($calendar_strategy->is_available( $start_time, "", $product_id,'time-picker'));
							// error_log(date("Y-m-d H:i"));
							// error_log(date("Y-m-d H:i",$start_time));	
							// error_log($calendar_strategy->is_available( $start_time, "", $product_id,'time-picker'));
							// error_log(strtotime(date("Y-m-d H:i")) < $start_time);
						if( $calendar_strategy->is_available( $start_time, "", $product_id)  &&  strtotime(date("Y-m-d H:i")) < $start_time ){ // if set rule not available in availability table  
							return date('Y-m-d',$curr_date);
						}
									
					}
					if( ($phive_enable_buffer == 'yes') && ($this->interval_period == $buffer_period)  ){
						$interval = $this->get_buffer_added_interval();
						
					}else{
						$interval = $this->interval;

					}
					$start_time = date( 'Y-m-d H:i', strtotime( "+$interval $this->interval_period", $start_time ) );
					$loop_breaker--;
				}
				// if set rule not available in availability table
				// if( $calendar_strategy->is_available( $curr_date, "", $product_id,$calendar_for) && in_array( date('N', $curr_date),  $this->get_booking_start_days($product_id) )){
				// 	return date('Y-m-1',$curr_date);
				// }
				// error_log(date ( "Y-m-d", strtotime( "+1 day", $curr_date ) ));
				// error_log(PHP_EOL);
				$curr_date = strtotime( date ( "Y-m-d", strtotime( "+1 day", $curr_date ) ) );
			}
		}
		private function get_buffer_added_interval(){

			$buffer_before_time 	= empty($this->buffer_before_time)?'0': $this->buffer_before_time;
			$buffer_after_time 		= empty($this->buffer_after_time)?'0': $this->buffer_after_time;
			$interval = $this->interval;
			if((($buffer_before_time%$this->interval) != 0) || (($buffer_after_time%$this->interval) != 0)){
				$interval += ($buffer_before_time + $buffer_after_time);
			}
			return $interval;
		}
		public function get_next_available_date($start_date,$product_id){
			$curr_date=strtotime(date("Y-m-d"));
			$curr_date=strtotime($start_date);
			$calendar_for='time-picker';
			$this->shop_opening_time		= get_post_meta( $product_id, "_phive_book_working_hour_start", 1 );
			$this->shop_closing_time		= get_post_meta( $product_id, "_phive_book_working_hour_end", 1 );
			$this->interval					= get_post_meta( $product_id, "_phive_book_interval", 1 );
			$this->interval_period			= get_post_meta( $product_id, "_phive_book_interval_period", 1 );
			$this->zone 					= get_option('gmt_offset');
			$this->buffer_before_time		= get_post_meta($product_id,"_phive_buffer_before",1);
			$this->buffer_after_time		= get_post_meta($product_id,"_phive_buffer_after",1);

			$buffer_period			=get_post_meta($product_id,"_phive_buffer_period",1);
			$phive_enable_buffer	= get_post_meta($product_id,"_phive_enable_buffer",1);
			if( ! class_exists('phive_booking_calendar_strategy') )
				include_once WP_PLUGIN_DIR . '/ph-bookings-appointments-woocommerce-premium/includes/frondend/class-ph-booking-calendar-strategy.php';
			$calendar_strategy=new phive_booking_calendar_strategy($product_id);
			// error_log("message");
			$end_date=strtotime(date('Y-m-d',strtotime("+1 year",$curr_date)));
			$count=0;
			while ($curr_date < $end_date && $count< 50) {
				// $count++;
				// $available_slot = $this->get_number_of_available_slot( $curr_date, $product_id, '');
				$date=date("Y-m-d",$curr_date);
				$start_time = $date.' '.$this->get_shop_opening_time($product_id,date("Y-m-d",$curr_date));
				// if(strtotime(date("Y-m-d H:i")) > strtotime($start_time))
				// {
				// 	$curr_date = strtotime( date ( "Y-m-d", strtotime( "+1 day", $curr_date ) ) );
				// 	continue;
				// }
				$end_time		= strtotime( "+1 day", strtotime(date('Y-m-d 00:00',(strtotime($start_time)))) );
				$interval=0;
				$loop_breaker 			= 200;
				// error_log("start");
				// error_log("start_time :  ".$start_time);
				// error_log("end_time :  ".date("Y-m-d H:i",$end_time));
				while ( strtotime($start_time) < $end_time && $loop_breaker>0 ) {
					// error_log($start_time);
					// error_log("inside");
					$start_time	= strtotime($start_time);
			
					if( $this->is_working_time( $start_time, $product_id )){
							// error_log($calendar_strategy->is_available( $start_time, "", $product_id));
							// error_log(date("Y-m-d H:i"));
							// error_log(date("Y-m-d H:i",$start_time));	
							// error_log($calendar_strategy->is_available( $start_time, "", $product_id));
							// error_log(strtotime(date("Y-m-d H:i")) < $start_time);
						if( $calendar_strategy->is_available( $start_time, "", $product_id)  &&  strtotime(date("Y-m-d H:i")) < $start_time ){ // if set rule not available in availability table  
							return date('Y-m-1',$curr_date);
						}
									
					}
					if( ($phive_enable_buffer == 'yes') && ($this->interval_period == $buffer_period)  ){
						$interval = $this->get_buffer_added_interval();
						
					}else{
						$interval = $this->interval;

					}
					// error_log("interval : ".$interval);
					// error_log(date( 'Y-m-d H:i', strtotime( "+$interval $this->interval_period", $start_time ) ) );
					// error_log("interval period : ".$this->interval_period);
					// error_log(date("Y-m-d H:i",$start_time));
					$start_time = date( 'Y-m-d H:i', strtotime( "+$interval $this->interval_period", $start_time ) );
					// error_log($start_time);
					$loop_breaker--;
				}
				// if set rule not available in availability table
				// if( $calendar_strategy->is_available( $curr_date, "", $product_id,$calendar_for) && in_array( date('N', $curr_date),  $this->get_booking_start_days($product_id) )){
				// 	return date('Y-m-1',$curr_date);
				// }
				// error_log(date ( "Y-m-d", strtotime( "+1 day", $curr_date ) ));
				// error_log(PHP_EOL);
				$curr_date = strtotime( date ( "Y-m-d", strtotime( "+1 day", $curr_date ) ) );
			}
			return $start_date;
		}
	private function is_working_time( $date, $product_id ){
		$time = strtotime( date('H:i',$date) );
		//if time falls in working hours
		if( (empty($this->shop_opening_time) && empty($this->shop_closing_time))
			|| !empty($this->shop_opening_time) && !empty($this->shop_closing_time) && $time >= strtotime($this->shop_opening_time) && $time <= strtotime($this->shop_closing_time)
			|| empty($this->shop_opening_time) && !empty($this->shop_closing_time) && $time <= strtotime($this->shop_closing_time)
			|| !empty($this->shop_opening_time) && empty($this->shop_closing_time) && $time >= strtotime($this->shop_opening_time)
			){
			return true;
		}
		return false;
	}
		public function get_booking_start_days($product_id){
			if( empty($this->restrict_start_day) ){
				$this->restrict_start_day = get_post_meta( $product_id, '_phive_restrict_start_day', 1 );
			}
			if( $this->restrict_start_day === 'yes' ){
				if( empty($this->booking_start_days) ){
					$this->booking_start_days	= get_post_meta( $product_id, '_phive_booking_start_days', 1 );
				}
			}else{
				$this->booking_start_days = array(1,2,3,4,5,6,7);
			}
			return $this->booking_start_days;
		}
		/**
		* Get the shop opening time
		*/
		public function get_shop_opening_time($product_id,$date=''){
			$zone= get_option('timezone_string');
			if(empty($zone)){
				$time_offset		= $this->zone;
				$zone				= timezone_name_from_abbr( "", $time_offset*60*60, 0 );
			}
			date_default_timezone_set($zone);
			$start_date=date('Y-m-d',strtotime($date));
			$shop_opening_time		= !empty( $this->shop_opening_time ) ? date( 'H:i',strtotime($this->shop_opening_time) ) : '00:00';
			return $shop_opening_time;
		}
		function phive_booking_scripts()
		{
			wp_enqueue_script( 'ph_booking_general_script_auto_select', plugins_url( '/resources/js/ph-booking-auto-select-date-for-customer.js', __FILE__ ), array( 'jquery' ) );
			wp_enqueue_style( 'ph_booking_auto_select_calendar_style', plugins_url( '/resources/css/ph_calendar_auto_select_date_for_customer_style.css', __FILE__ ));
			//$rules=get_option(PH_BOOKING_SETTING_ID,false);
			
			wp_localize_script( 'ph_booking_general_script_auto_select', 'phive_booking_auto_select_js', array('ajaxurl'=>admin_url( 'admin-ajax.php' )) );
			

		}
		function plugin_action_links( $links ) {
		
			$plugin_links = array(
				// '<a href="'.admin_url('admin.php?page=booking-cost-adjustment-settings').'" >' . __('Settings', 'bookings-and-appointments-for-woocommerce') . '</a>',
			);
			return array_merge( $plugin_links, $links );
		
		}

	}
}
new Ph_Bookings_Auto_Select_Next_Available_Date_For_Customer();